Main Page Modules Class Hierarchy Alphabetical List Compound List File List Compound Members

# SoCylinder Class Reference
[Nodes]

The SoCylinder class is for rendering cylinder shapes. More...

`#include <Inventor/nodes/SoCylinder.h>`

Inheritance diagram for SoCylinder:

List of all members.

## Public Types
enum | Part
## Public Methods
| SoCylinder (void)
void | addPart (SoCylinder::Part part)
void | removePart (SoCylinder::Part part)
SbBool | hasPart (SoCylinder::Part part) const
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | GLRender (SoGLRenderAction *action)
## Static Public Methods
void | initClass (void)
## Public Attributes
SoSFFloat | radius
SoSFFloat | height
SoSFBitMask | parts
## Protected Methods
virtual | ~SoCylinder ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

## Detailed Description

The SoCylinder class is for rendering cylinder shapes.

Insert a cylinder shape into the scenegraph. The cylinder is rendered with the current material, texture and drawstyle settings (if any, otherwise the default settings are used).

The SoCylinder node class is provided as a convenient abstraction for the application programmer to use "complex" shapes of this type without having to do the tessellation to polygons and other low-level programming herself.

A cylinder is visualized by the underlying rendering system by first tessellating the conceptual cylinder into a set of polygons. To control the trade-off between an as much as possible correct visual appearance of the cylinder versus fast rendering, use an SoComplexity node to influence the number of polygons generated from the tessellation process. (The higher the complexity value, the more polygons will be generated, the more rounded the sides of the cylinder will look.) Set the SoComplexity::value field to what you believe would be a good trade-off between correctness and speed for your particular application.

See also:
  SoCone, SoSphere, SoCube

## Member Enumeration Documentation

enum SoCylinder::Part

| The parts of a cylinder shape.

## Constructor & Destructor Documentation

SoCylinder::SoCylinder | ( | void |  | ) |

| Constructor.

SoCylinder::~SoCylinder | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoCylinder::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoShape.

void SoCylinder::addPart | ( | SoCylinder::Part | part | ) |

| Add a part to the cylinder. See also: removePart(), hasPart()

void SoCylinder::removePart | ( | SoCylinder::Part | part | ) |

| Remove a part from the cylinder. See also: addPart(), hasPart()

SbBool SoCylinder::hasPart | ( | SoCylinder::Part | part | ) | const

| Returns `TRUE` if rendering of the given part is currently turned on. See also: addPart(), removePart()

void SoCylinder::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoCylinder::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoCylinder::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoCylinder::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

| The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().) The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller. Implements SoShape.

void SoCylinder::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

| Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box. The bounding box and center point should be calculated and returned in the local coordinate system. The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().) The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry. Implements SoShape.

## Member Data Documentation

SoSFFloat SoCylinder::radius

| Radius of cylinder. Default value 1.0.

SoSFFloat SoCylinder::height

| Height of cylinder. Default is 2.0.

SoSFBitMask SoCylinder::parts

| Which parts to use for rendering, picking, etc. Defaults to SoCylinder::ALL.

The documentation for this class was generated from the following files:

- SoCylinder.h
- SoCylinder.cpp